#include "cmd.h"
#include "hardw.h"

/* ------------------------EP610 routines-------------------------- */

char chEP610_init(char c)
{
  msg.cmd.voltage = 120;
  init_setting();
  set_Upp0(Upp_0);
  set_Upp1(Upp_0);
}

char chEP610_set_addr(char c)
{
  int a;

  if (c)                              /* Conditional write not allowed */
  {
    msg.ans.ans = anError;
    msg.ans.err = erMode;
    return(0);
  }
  a = msg.cmd.address.lw.LO_WORD << 1;
  PPA1[KA] = msg.cmd.address.lc.LO_LO_CHAR;
  PPA1[KB] = hi_byte(a);
  return(1);
}

char chEP610_read(char c)
{
  if (Switch_Off)
  {
    msg.ans.ans = anError;
    msg.ans.err = erSwOff;
    return(0);
  }
  PPA2[KB] = 0xFF;                    /* Initialize read mode */
  set_Upp0(Upp);                      /* Upp0 = 12V */
  set_Upp1(Upp);                      /* Upp1 = 12V */
  c = PPA2[KA];                       /* Get data */
  set_Upp1(Upp_0);                    /* Upp0 = 0V */
  set_Upp0(Upp_0);                    /* Upp0 = 0V */
  return(c);
}

char chEP610_write(char c)
{
  if (! Switch_Off)
  {
    set_Upp0(Upp_5V);                 /* Upp0 = 5V */
    set_Upp1(Upp);                    /* Upp1 = 12V */
    PPA2[KB] = c;                     /* Set data */
    set_Upp0(Upp_0);                  /* Upp0 = 0V Give a pulse */
    delay1ms(1);                      /* Wait for 1 ms */
    set_Upp0(Upp_5V);                 /* Upp0 = 5V */
    set_Upp1(Upp_0);                  /* Upp0 = 0V */
  }
  else
  {
    msg.ans.ans = anError;
    msg.ans.err = erSwOff;
    return(0);
  }
  return(1);                          /* Success */
}

/* ------------------------EP910 routines-------------------------- */

char chEP910_set_addr(char c)
{
  if (c)                              /* Conditional write not allowed */
  {
    msg.ans.ans = anError;
    msg.ans.err = erMode;
    return(0);
  }
  PPA1[KA] = msg.cmd.address.lc.LO_LO_CHAR;
  PPA1[KB] = msg.cmd.address.lc.LO_HI_CHAR;
  return(1);
}