#include "xfer.h"
#include "cmd.h"
#include "fnn.h"
#include "hardw.h"
#include "ovr.h"
#include "27xx.h"
#include "28F256A.h"
#include "892051.h"
#include "90S1200.h"
#include "8951.h"
#include "556RTxx.h"
#include "610910.h"

/* user */
/* 2708, 01 */
/* 2716, 02 */
/* 2732, 03 */
/* 2764, 04 */
/* 27256, 05 */
/* 27512, 06 */
/* 27010, 07 */
/* 28F256A, 08 */
/* 892051, 09 */
/* 90S1200P, 10 */
/* 90S1200E, 11 */
/* 8951, 12 */
/* 155RE3, 13 */
/* 556RT4, 14 */
/* 556RT5, 15 */
/* 556RT7, 16 */
/* 556RT16, 17 */
/* EP610, 18 */
/* EP910, 19 */

enum {chUser, ch2708, ch2716, ch2732, ch2764, ch27256, ch27512,
      ch27010, ch28256, ch2051, ch90S1200P, ch90S1200E, ch8951,
      ch155RE3, ch556RT4, ch556RT5, ch556RT7, ch556RT16, chEP610,
      chEP910, ch_nums};

char user(char c);
char mode_error(char c);

#define CHIP(ch, init, set_Upr, set_addr, read, erase, write, wr_pins )\
    case ch * fn_nums + fn_chip_init     : return(init(c));\
    case ch * fn_nums + fn_chip_set_Upr  : return(set_Upr(c));\
    case ch * fn_nums + fn_chip_set_addr : return(set_addr(c));\
    case ch * fn_nums + fn_chip_read     : return(read(c));\
    case ch * fn_nums + fn_chip_erase    : return(erase(c));\
    case ch * fn_nums + fn_chip_write    : return(write(c));\
    case ch * fn_nums + fn_chip_wr_pins  : return(wr_pins(c))\

char valid_chip(void)
{
  return(msg.cmd.chip < ch_nums);
}

char call_(char f, char c)
{
  f = msg.cmd.chip * fn_nums + f;
  switch (f)
  {
    CHIP(chUser, ov_chip_init, mode_error, ov_chip_set_addr,
         ov_chip_read, ov_chip_erase, ov_chip_write, mode_error);

    CHIP(ch2708, ch2708_init, mode_error, set_address,
         ch2708_read, mode_error, ch2708_write, mode_error);

    CHIP(ch2716, ch27xx_init, ch2716_set_Upr, set_address,
         ch27xx_read, mode_error, ch27xx_write, ch2716_wr_pins);

    CHIP(ch2732, ch27xx_init, ch2732_set_Upr, ch2732_set_addr,
         ch27xx_read, mode_error, ch27xx_write, ch2716_wr_pins);

    CHIP(ch2764, ch27xx_init, ch2716_set_Upr, ch2764_set_addr,
         ch27xx_read, mode_error, ch27xx_write, ch2764_wr_pins);

    CHIP(ch27256, ch27xx_init, ch2716_set_Upr, set_address,
         ch27xx_read, mode_error, ch27xx_write, ch27256_wr_pins);

    CHIP(ch27512, ch27xx_init, ch2732_set_Upr, ch27512_set_addr,
         ch27xx_read, mode_error, ch27xx_write, ch27256_wr_pins);

    CHIP(ch27010, ch27xx_init, ch27010_set_Upr, ch28F256A_set_addr,
         ch27xx_read, mode_error, ch27xx_write, ch27010_wr_pins);

    CHIP(ch28256, ch28F256A_init, mode_error, ch28F256A_set_addr,
         ch28F256A_read, ch28F256A_erase, ch28F256A_write, mode_error);

    CHIP(ch2051, ch2051_init, mode_error, ch2051_set_addr,
         ch2051_read, ch2051_erase, ch2051_write, mode_error);

    CHIP(ch90S1200P, ch90S1200P_init, mode_error, ch90S1200P_set_addr,
         ch90S1200P_read, ch90S1200P_erase, ch90S1200P_write, mode_error);

    CHIP(ch90S1200E, ch90S1200P_init, mode_error, ch90S1200P_set_addr,
         ch90S1200E_read, ch90S1200P_erase, ch90S1200E_write, mode_error);

    CHIP(ch8951, ch8951_init, mode_error, ch8951_set_addr,
         ch8951_read, ch8951_erase, ch8951_write, mode_error);

    CHIP(ch155RE3, chRE_RT_init, mode_error, ch155RE3_set_addr,
         ch155RE3_read, mode_error, ch155RE3_write, mode_error);

    CHIP(ch556RT4, chRE_RT_init, mode_error, ch556RT4_set_addr,
         ch556RT4_read, mode_error, ch556RT4_write, mode_error);

    CHIP(ch556RT5, chRE_RT_init, mode_error, ch556RT5_set_addr,
         ch556RT5_read, mode_error, ch556RT5_write, mode_error);

    CHIP(ch556RT7, chRE_RT_init, mode_error, ch556RT7_set_addr,
         ch155RE3_read, mode_error, ch155RE3_write, mode_error);

    CHIP(ch556RT16, chRE_RT_init, mode_error, ch556RT16_set_addr,
         ch155RE3_read, mode_error, ch155RE3_write, mode_error);

    CHIP(chEP610, chEP610_init, mode_error, chEP610_set_addr,
         chEP610_read, mode_error, chEP610_write, mode_error);

    CHIP(chEP910, chEP610_init, mode_error, chEP910_set_addr,
         chEP610_read, mode_error, chEP610_write, mode_error);

/*  Insert new chip here */

  }
  return (0);
}