#include "cmd.h"
#include "hardw.h"

#define CS F_4

/* ------------------------55616 routines-------------------------- */

char usr_chip_init(char c)
{
}

char usr_chip_set_addr(char c)
{
  PPA1[KA] = msg.cmd.address.lc.LO_LO_CHAR;
  PPA1[KB] = msg.cmd.address.lc.LO_HI_CHAR;
  if (msg.cmd.address.lc.LO_HI_CHAR & 2) F_1 = 1;
  else F_1 = 0;
  return(1);
}

char usr_chip_read(char c)
{
  char mask;

  if (Switch_Off)                     /* Must be turned ON (hardware-defined): */
  {
    msg.ans.ans = anError;
    msg.ans.err = erSwOff;
    return(0);
  }
  PPA2[KB] = 0xFF;                    /* Initialize read mode */
  CS = 0;                             /* CS = 0V */
  F_3 = 0;                            /* Ucc = 5V */
  c = 0;                              /* Set initial value */
  mask = 0xFE;                        /* Set initial read mask */
  do
  {
    PPA2[KB] = mask;                  /* Select data bit */
    c >>= 1;                          /* Read data bit*/
    if (! F_6) c |= 0x80;
    mask = (mask << 1) | 1;           /* Shift mask bits and invert */
  } while (mask != 0xFF);
  F_3 = 1;                            /* Ucc = 0V */
  CS = 1;                             /* CS = 5V */
  return(c);
}

char usr_chip_erase(char c)
{}

char usr_chip_write(char c)
{
  char mask;
  int cnt;

  if (! Switch_Off)
  {
    mask = 0xFE;                      /* Initialize mask */
    do
    {
      PPA2[KB] = mask;                /* Select data bit */
      if (c & ~mask)                  /* This bit needs to be programmed */
      {
        for (cnt = 0; cnt < 1000; cnt++)
        {
          F_3 = 0;                    /* Ucc = 5V */
          CS = 1;                     /* CS = 5V */
          F_2 = 0;                    /* Ucc = 12.5V */
          F_3 = 1;                    /* Give a pulse */
          delay10us(3);               /* Wait for 30 us */
          F_2 = 1;                    /* Ucc = 0V */
          CS = 0;                     /* CS = 0V */
          delay10us(30);              /* Wait for 300 us */
          F_3 = 0;                    /* Ucc = 5V */
          if (! F_6)
          {
            F_3 = 1;                  /* Ucc = 0 */
            break;                    /* Ok */
          }
          F_3 = 1;                    /* Ucc = 0 */
        }
        if (cnt >= 1000)              /* Write error */
        {
          msg.ans.ans = anError;
          msg.ans.err = erWrite;
          return(0);
        }
      }
      mask = (mask << 1) | 1;         /* Shift mask bits and invert */
    } while (mask != 0xFF);
  }
  else
  {
    msg.ans.ans = anError;
    msg.ans.err = erSwOff;
    return(0);
  }
  return(1);                          /* Success */
}
