#include "xfer.h"
#include "cmd.h"
#include "hardw.h"
#include "prgprocs.h"
#include "fnn.h"

union message msg;

void main(void)
{
  signed char res;
  init_setting();
  for(;;)
   {
     while ((res = receive_pkt((char *)&msg, sizeof(msg))) < 0);
     if (res == sizeof(msg))
       {
        if (msg.cmd.mode == mHandshake)
         {
           res = anOk;
           goto lHandshake;
         }
        else
         {
           init_setting();
           if (!valid_chip())
            {
             res = anError;
             msg.ans.err = erUnknownChip;
            }
           else
            {
              res = anOk;
              send_pkt((char *)&res, 1, 0);

              switch (msg.cmd.mode)
              {
                case mWrite_verify:
                case mVerify:
                case mUWrite:
                case mLoad:
                case mWrite:        res = pWrite(); break;
                case mRead:
                case mReadRAM:      res = pRead(); break;
                case mErase_verify: res = pErase_Verify(); break;
                case mErase:        res = pErase(); break;
                case mUErase:       res = pUErase(); break;
                case mSet_Upr:      res = pSet_Upr(1); break;
                case mReset_Upr:    res = pSet_Upr(0); break;
                case mLock_Read:    res = pLock_Read(); break;
                case mLock_Write:   res = pLock_Write(); break;
                case mLock_Ex:      res = pLock_Ex(); break;
                case mRun:          res = anOk;
                                    send_pkt((char *)&res, 1, 0);
                                    pRun(); break;
                default:            res = 0; msg.ans.err = erMode; break;
              }
            }
     lHandshake:
           if (msg.cmd.mode != mSet_Upr) init_setting();
           msg.ans.ans = res;
           send_pkt((char *)&msg, sizeof(msg), 0);
         }
       }
   }
}